import matplotlib.pyplot as plt
import numpy as np
import pandas as pd
from sklearn.svm import SVC
from sklearn.model_selection import KFold
from sklearn.linear_model import LogisticRegression
from sklearn.discriminant_analysis import LinearDiscriminantAnalysis
from sklearn.discriminant_analysis import QuadraticDiscriminantAnalysis

# Z= np.genfromtxt('hw1.csv',delimiter=',')
# y=Z[:,2]
# X=Z[:, 0:2]

# Load data
df = pd.read_csv("hw1.csv",sep = ",", header=None)
X=df.values[:,0:2]
y=df.values[:,2]

# Scatter plot
I=y>0.5
J=y<0.5
plt.scatter(X[I, 0], X[I, 1], c='red', s=40, alpha=0.1)
plt.scatter(X[J, 0], X[J, 1], c='blue', s=40, alpha=0.1)

#Logistic regression
clf = LogisticRegression(random_state=0, solver='newton-cg', 
                        multi_class='multinomial').fit(X, y)
clf.predict([[-1,0.5]])

# SVM
# clf=SVC(kernel='poly', degree=2, C=10, gamma=1, coef0=1)
# clf.fit(X, y)

# # clf = LinearDiscriminantAnalysis()
# # clf.fit(X, y)

# # clf2 = QuadraticDiscriminantAnalysis()
# # clf2.fit(X, y)


min_x = np.min(X[:, 0])
max_x = np.max(X[:, 0])
min_y = np.min(X[:, 1])
max_y = np.max(X[:, 1])
xx, yy = np.meshgrid(np.arange(min_x, max_x, 0.01), np.arange(min_y, max_y, 0.01))
Z = clf.decision_function(np.c_[xx.ravel(), yy.ravel()])
Z = Z.reshape(xx.shape)
plt.contour(xx, yy, Z, [0], cmap=plt.cm.get_cmap("Spectral"), linewidths=2)
# Z2 = clf2.decision_function(np.c_[xx.ravel(), yy.ravel()])
# Z2 = Z2.reshape(xx.shape)
# plt.contour(xx, yy, Z2, [0], cmap=plt.cm.get_cmap("Spectral"), linewidths=2)
plt.show()

# # KFold

kf = KFold(n_splits=10, shuffle=True)
s=np.zeros(10)
i=0
for train_index, test_index in kf.split(X):
    X_train, X_test = X[train_index], X[test_index]
    y_train, y_test = y[train_index], y[test_index]
    clf=SVC(kernel='poly', degree=2, gamma=1, C=1, coef0=1)
    clf.fit(X_train, y_train)
    s[i]=clf.score(X_test, y_test)
    i=i+1
print(s)